// JScript 文件
//分类管理
//000000分类列表开始
var ClassInfoStore;
ClalssInfoManage = function(node) {//分页每页显示数量	 
    var pageSize = 500;
    //指定列参数

    var ClassInfofields = ["ID", "ClassName", "ParentId", "Depth", "RootId", "OrderId", "Readme", "Child", "Intro"];
    ClassInfoStore = new Ext.data.GroupingStore({
        proxy: new Ext.data.HttpProxy(
           {
               url: "/MCScriptManageServices/ClassInfo.aspx",
               method: "POST"
           }),
        reader: new Ext.data.JsonReader(
           {
               fields: ClassInfofields,
               root: "data",
               id: "ID",
               totalProperty: "totalCount"

           })
        //groupField:'id',
        
    });
    ClassInfoStore.load({ params: { start: 0, limit: pageSize} });




    //--------------------------------------------------列选择模式
    var sm = new Ext.grid.CheckboxSelectionModel({
    //dataIndex:"id"
});
//--------------------------------------------------列头
var cm = new Ext.grid.ColumnModel([
		sm,
{
    header: "分类名称",
    dataIndex: "ClassName",
    tooltip: "分类名称",
    sortable: true
}, {
    header: "简介",
    tooltip: "简介",
    dataIndex: "Intro",
    sortable: true
}]);


    var ClassGrid = new Ext.grid.GridPanel({
    id: "ClassGrid",
        store: ClassInfoStore,
        sm: sm,
        cm: cm,
        loadMask: true,
        stripeRows: true,
        //autoExpandColumn:7,
        //超过长度带自动滚动条
        autoScroll: true,
        border: false,
        view: new Ext.grid.GroupingView({
            //自动填充
            forceFit: true,
            sortAscText: '正序排列',
            sortDescText: '倒序排列',
            columnsText: '列显示/隐藏',
            groupByText: '根据本列分组',
            showGroupsText: '是否采用分组显示',
            groupTextTpl: '{text} (<font color=red><b>{[values.rs.length]}</b></font> {[values.rs.length > 0 ? "条器件信息" : "暂无器件信息"]})'
        }),
        //分页
        bbar: new Ext.PagingToolbar({
            store: ClassInfoStore,
            pageSize: pageSize,
            //显示右下角信息
            displayInfo: true,
            displayMsg: '当前记录 {0} -- {1} 条 共 {2} 条记录',
            emptyMsg: "No results to display",
            prevText: "上一页",
            nextText: "下一页",
            refreshText: "刷新",
            lastText: "最后页",
            firstText: "第一页",
            beforePageText: "当前页",
            afterPageText: "共{0}页"

        }),
        tbar: [
		new Ext.Toolbar.Fill()
		, "", "-", "",
			{
			    text: "刷新信息",
			    //默认样式为按下
			    //pressed:true,
			    tooltip: "刷新当前页面信息",
			    iconCls: "refreshicon",
			    handler: function() {
			        ClassInfoStore.reload();
			    }
			}, "", "-"
		,
		{
		    text: "添加",
		    tooltip: "添加分类信息",
		    iconCls: "addicon",
		    handler: AddClassInfoFn
		}, "", "-", "", {
		    text: "编辑",
		    tooltip: "编辑分类信息",
		    iconCls: "editicon",
		    handler: EditClassInfoFn
		}, "", "-", "", {
		    text: "删除",
		    tooltip: "删除分类信息",
		    iconCls: "deleteicon",
		    handler: DelClassInfoFn

		}, "-"], listeners: {
		    'contextmenu': function(e) {
		        e.stopEvent();
		    },
		    'rowcontextmenu': function(grid, rowIndex, e) {
		        e.stopEvent();
		    }
		}
    });



    GridMain(node, ClassGrid, "usericon");
}

function DelClassInfoFn() {
    var row = Ext.getCmp("ClassGrid").getSelectionModel().getSelections();
    if (row.length == 0) {
        Ext.Msg.alert("提示信息", "请您至少选择一个!");
    }
    else {
        Ext.Msg.confirm("提示!", "您确定要删除该分类信息吗?", function(btn) {
            if (btn == "yes") {
                DeleteClassInfoFn(row);
            }
            else {

            }
        })
    }
}

function EditClassInfoFn() {
    var row = Ext.getCmp("ClassGrid").getSelectionModel().getSelections();
    if (row.length == 0) {
        Ext.Msg.alert("提示信息", "您没有选中任何行!");
    }
    else if (row.length > 1) {

        Ext.Msg.alert("提示信息", "对不起只能选择一个!");
    } else if (row.length == 1) {

        EditClassInfos(row[0]); //传行一行记录直接加载
    }
}

//000000分类管理结束
//000000分类添加开始


AddClassInfoFn = function() {
    //------分类类型

var AddClassRoleFields = Ext.data.Record.create([
        { name: 'ID', mapping: 'ID' }, { name: 'ClassName', mapping: 'ClassName' }                     
    ]);    

            var AddClassStore = new Ext.data.Store({
            proxy: new Ext.data.HttpProxy({
            url: '/MCScriptManageServices/ClassInfoByPid.aspx'
            }),
            reader: new Ext.data.JsonReader({
                root: 'data',
                id: 'ID'
            },
           AddClassRoleFields
            )
        });
        AddClassStore.load();


    var AddClassInfoForm = new Ext.form.FormPanel({
        width: 315,
        plain: true,
        layout: "form",
        defaultType: "textfield",
        labelWidth: 60,
        baseCls: "x-plain",
        defaults: { anchor: "95%", msgTarget: "side" },
        buttonAlign: "center",
        bodyStyle: "padding:0 0 0 0",
        items: [
			{
			    name: "ClassName",
			    fieldLabel: "分类名称",
			    allowBlank: false,
			    blankText: "分类名称"
			},
						{

						    xtype: "combo",
						    tpl: '<tpl for="."><div ext:qtip="{ClassName}" class="x-combo-list-item">{ClassName}</div></tpl>',
						    store: AddClassStore,
						    typeAhead: true,
						    fieldLabel: '父分类',
						    hiddenName: 'ParentId',
						    name: 'ParentId',
						    forceSelection: true,
						    triggerAction: 'all',
						    emptyText: '选择父分类',
						    selectOnFocus: true,
						    width: 130,
						    editable: false,
						    allowBlank: false,
						    blankText: '请选择父分类',
						    displayField: 'ClassName',
						    valueField: 'ID',
						    mode: 'remote'
						}, 
						

			{
			    name: "Intro",
			fieldLabel: "备注描述",
			allowBlank: false,
			blankText: "备注描述不能为空"

}
			]
    });


    var AddClassInfoWin = new Ext.Window({
        title: "添加新分类",
        width: 350,
        plain: true,
        layout: "form",
        iconCls: "addicon",
        //不可以随意改变大小
        resizable: false,
        //是否可以拖动
        //draggable:false,
        defaultType: "textfield",
        labelWidth: 100,
        collapsible: true, //允许缩放条
        closeAction: 'hide',
        closable: true,
        //弹出模态窗体
        modal: 'true',
        buttonAlign: "center",
        bodyStyle: "padding:10px 0 0 15px",
        items: [AddClassInfoForm],
        listeners: {
            "show": function() {
                AddClassInfoForm.getForm().reset();
            }
        },
        buttons: [{
            text: "保存信息",
            minWidth: 70,
            handler: function() {
                if (AddClassInfoForm.getForm().isValid()) {
                    //弹出效果
                    Ext.MessageBox.show
                                (
                                    {
                                        msg: '正在保存，请稍等...',
                                        progressText: 'Saving...',
                                        width: 300,
                                        wait: true,
                                        waitConfig: { interval: 200 },
                                        icon: 'download',
                                        animEl: 'saving'
                                    }
                                );
                    setTimeout(function() { }, 1000);
                    AddClassInfoForm.form.submit({
                        url: "/MCScriptManageServices/AddClassInfo.aspx",
                        method: "POST",
                        success: function(form, action) {
                            //成功后
                            var flag = action.result.success;
                            if (flag == "true") {
                                Ext.MessageBox.alert("恭喜", "添加新分类成功!");
                                ClassInfoStore.reload();
                                AddClassInfoWin.hide();
                            } else if (flag == "false") {

                                var reson = action.result.reson;
                                //Ext.MessageBox.alert("提示",""+reson+"!");
                                if (reson != "undefined")
                                    Ext.MessageBox.alert("提示", "系统已存在此分类名!");
                            }
                        },
                        failure: function(form, action) {
                            Ext.MessageBox.alert("提示!", "添加新分类失败!");
                        }
                    });
                }
            }
        }, {
            text: "重置",
            minWidth: 70,
            qtip: "重置数据",
            handler: function() {
                AddClassInfoForm.getForm().reset();
            }
        }, {
            text: "取 消",
            minWidth: 70,
            handler: function() {
                AddClassInfoWin.hide();
            }
}]

        });
        AddClassInfoWin.show();
    }

    //000000分类添加结束
    //000000分类编辑开始
    EditClassInfos = function(row) {
        //------分类类型

var AddClassRoleFields = Ext.data.Record.create([
        { name: 'ID', mapping: 'ID' }, { name: 'ClassName', mapping: 'ClassName' }                     
    ]);    

            var AddClassStore = new Ext.data.Store({
            proxy: new Ext.data.HttpProxy({
            url: '/MCScriptManageServices/ClassInfoByPid.aspx'
            }),
            reader: new Ext.data.JsonReader({
                root: 'data',
                id: 'ID'
            },
           AddClassRoleFields
            )
        });
        AddClassStore.load();

        var EditClassInfoForm = new Ext.form.FormPanel({
            width: 315,
            plain: true,
            layout: "form",
            defaultType: "textfield",
            labelWidth: 60,
            baseCls: "x-plain",
            defaults: { anchor: "95%", msgTarget: "side" },
            buttonAlign: "center",
            bodyStyle: "padding:0 0 0 0",
            items: [
						{
						    xtype: 'hidden',
						    name: "ID",
						    fieldLabel: "登录帐号",
						    allowBlank: false,
						    blankText: "帐号不允许为空",
						    readOnly: true
						}	,		{
			    name: "ClassName",
			    fieldLabel: "分类名称",
			    allowBlank: false,
			    blankText: "分类名称"
			},
						{

						    xtype: "combo",
						    tpl: '<tpl for="."><div ext:qtip="{ClassName}" class="x-combo-list-item">{ClassName}</div></tpl>',
						    store: AddClassStore,
						    typeAhead: true,
						    fieldLabel: '父分类',
						    hiddenName: 'ParentId',
						    name: 'ParentId',
						    forceSelection: true,
						    triggerAction: 'all',
						    emptyText: '选择父分类',
						    selectOnFocus: true,
						    width: 130,
						    editable: false,
						    allowBlank: false,
						    blankText: '请选择父分类',
						    displayField: 'ClassName',
						    valueField: 'ID',
						    mode: 'remote'
						}, 
						

			{
			    name: "Intro",
			fieldLabel: "备注描述",
			allowBlank: false,
			blankText: "备注描述不能为空"

}
			]
        });


        var EditClassInfoWin = new Ext.Window({
            title: "编辑分类信息",
            width: 350,
            plain: true,
            //layout:"form",
            iconCls: "addicon",
            //不可以随意改变大小
            resizable: false,
            //是否可以拖动
            //draggable:false,
            defaultType: "textfield",
            labelWidth: 100,
            collapsible: true, //允许缩放条
            closeAction: 'hide',
            closable: true,
            //弹出模态窗体
            modal: 'true',
            buttonAlign: "center",
            bodyStyle: "padding:10px 0 0 15px",
            items: [EditClassInfoForm],
            listeners: {
                "show": function() {

                    EditClassInfoForm.getForm().reset();
                    var classid_input = row.data.ID;
                    AddClassStore.load();
                    EditClassInfoForm.form.load(
                                {
                                    url: "/MCScriptManageServices/LoadClassInfo.aspx?id=" + classid_input,
                                    method: "get",
                                    success: function(form, action) {

                                    },
                                    failure: function(form, action) {
                                        Ext.Msg.alert("提示信息", "对不起加载数据失败!请联系管理员");
                                    }
                                }
                    );
                }
            },
            buttons: [{
                text: "保存信息",
                minWidth: 70,
                handler: function() {
                    if (EditClassInfoForm.getForm().isValid()) {
                        //弹出效果
                        Ext.MessageBox.show
                                (
                                    {
                                        msg: '正在保存，请稍等...',
                                        progressText: 'Saving...',
                                        width: 300,
                                        wait: true,
                                        waitConfig: { interval: 200 },
                                        icon: 'download',
                                        animEl: 'saving'
                                    }
                                );
                        setTimeout(function() { }, 1000);
                        EditClassInfoForm.form.submit({
                            url: "/MCScriptManageServices/UpdateClassInfo.aspx",
                            method: "POST",
                            success: function(form, action) {
                                //成功后
                                var flag = action.result.success;
                                if (flag == "true") {
                                    Ext.MessageBox.alert("恭喜", "保存分类信息成功!");
                                    ClassInfoStore.reload();
                                    EditClassInfoWin.hide();
                                } else if (flag == "false") {

                                    Ext.MessageBox.alert("提示", "您的分类名可能系统中已经存在，请换一个分类名试下!");
                                    ClassInfStore.reload();
                                    EditClassInfoWin.hide();
                                }
                            },
                            failure: function(form, action) {
                                Ext.MessageBox.alert("提示!", "保存分类信息失败!");
                            }
                        });
                    }
                }
            }, {
                text: "重置",
                minWidth: 70,
                qtip: "重置数据",
                handler: function() {
                    var classid_input = row.data.id;
                    EditClassInfoForm.form.load(
                                {
                                    url: "/MCScriptManageServices/LoadClassInfo.aspx?loginid=" + classid_input,
                                    method: "get",
                                    success: function(form, action) {

                                    },
                                    failure: function(form, action) {
                                        Ext.Msg.alert("提示信息", "对不起加载数据失败!请联系管理员");
                                    }
                                }
                    );
                }
            }, {
                text: "取 消",
                minWidth: 70,
                handler: function() {
                    EditClassInfoWin.hide();
                }
}]

            });
            EditClassInfoWin.show();
        }

        //000000分类编辑结束
        //000000分类删除开始

        DeleteClassInfoFn = function(row) {
            var deletesplit = "";
            for (var i = 0; i < row.length; i++) {
                if (row.length == 1) {
                    deletesplit = row[i].data.ID;
                }
                else {

                    if (i < (row.length - 1)) {
                        deletesplit = row[i].data.ID + "," + deletesplit;
                    }
                    if (i == (row.length - 1)) {
                        deletesplit = deletesplit + row[i].data.ID;
                    }
                }
            }
            Ext.Ajax.request({
                url: "/MCScriptManageServices/DeleteClassInfo.aspx",
                method: "POST",
                params: {
                    id: deletesplit
                },
                success: function() {
                    ClassInfoStore.reload();
                },
                failure: function() {
                    Ext.Msg.alert("提 示", "删除失败了!");
                }
            });
        }

        //000000分类删除结束